/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-08-01 15:32:38 UTC)
 * on 2013-08-05 at 19:30:42 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.youtube.model;

/**
 * A subscription resource contains information about a YouTube user subscription. A subscription
 * notifies a user when new videos are added to a channel or when another user takes one of several
 * actions on YouTube, such as uploading a video, rating a video, or commenting on a video.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the YouTube Data API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class Subscription extends com.google.api.client.json.GenericJson {

  /**
   * The contentDetails object contains basic statistics about the subscription.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private SubscriptionContentDetails contentDetails;

  /**
   * Etag of this resource.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String etag;

  /**
   * The ID that YouTube uses to uniquely identify the subscription.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String id;

  /**
   * The kind, fixed to "youtube#subscription".
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String kind;

  /**
   * The snippet object contains basic details about the subscription, including its title and the
   * channel that the user subscribed to.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private SubscriptionSnippet snippet;

  /**
   * The subscriberSnippet object contains basic details about the sbuscriber.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private SubscriptionSubscriberSnippet subscriberSnippet;

  /**
   * The contentDetails object contains basic statistics about the subscription.
   * @return value or {@code null} for none
   */
  public SubscriptionContentDetails getContentDetails() {
    return contentDetails;
  }

  /**
   * The contentDetails object contains basic statistics about the subscription.
   * @param contentDetails contentDetails or {@code null} for none
   */
  public Subscription setContentDetails(SubscriptionContentDetails contentDetails) {
    this.contentDetails = contentDetails;
    return this;
  }

  /**
   * Etag of this resource.
   * @return value or {@code null} for none
   */
  public java.lang.String getEtag() {
    return etag;
  }

  /**
   * Etag of this resource.
   * @param etag etag or {@code null} for none
   */
  public Subscription setEtag(java.lang.String etag) {
    this.etag = etag;
    return this;
  }

  /**
   * The ID that YouTube uses to uniquely identify the subscription.
   * @return value or {@code null} for none
   */
  public java.lang.String getId() {
    return id;
  }

  /**
   * The ID that YouTube uses to uniquely identify the subscription.
   * @param id id or {@code null} for none
   */
  public Subscription setId(java.lang.String id) {
    this.id = id;
    return this;
  }

  /**
   * The kind, fixed to "youtube#subscription".
   * @return value or {@code null} for none
   */
  public java.lang.String getKind() {
    return kind;
  }

  /**
   * The kind, fixed to "youtube#subscription".
   * @param kind kind or {@code null} for none
   */
  public Subscription setKind(java.lang.String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * The snippet object contains basic details about the subscription, including its title and the
   * channel that the user subscribed to.
   * @return value or {@code null} for none
   */
  public SubscriptionSnippet getSnippet() {
    return snippet;
  }

  /**
   * The snippet object contains basic details about the subscription, including its title and the
   * channel that the user subscribed to.
   * @param snippet snippet or {@code null} for none
   */
  public Subscription setSnippet(SubscriptionSnippet snippet) {
    this.snippet = snippet;
    return this;
  }

  /**
   * The subscriberSnippet object contains basic details about the sbuscriber.
   * @return value or {@code null} for none
   */
  public SubscriptionSubscriberSnippet getSubscriberSnippet() {
    return subscriberSnippet;
  }

  /**
   * The subscriberSnippet object contains basic details about the sbuscriber.
   * @param subscriberSnippet subscriberSnippet or {@code null} for none
   */
  public Subscription setSubscriberSnippet(SubscriptionSubscriberSnippet subscriberSnippet) {
    this.subscriberSnippet = subscriberSnippet;
    return this;
  }

  @Override
  public Subscription set(String fieldName, Object value) {
    return (Subscription) super.set(fieldName, value);
  }

  @Override
  public Subscription clone() {
    return (Subscription) super.clone();
  }

}
